/*
 * dhdiff 1.0 by Paul Falstad (pf@z-code.com)
 */


#include <stdio.h>

char *tattr[] = {
    "thing no", "first frame", "toughness", "moving frame",
    "see player sound", "reaction time", "attack sound", "injury frame",
    "pain chance", "pain sound", "close attack frame", "distance attack frame",
    "death frame", "explode frame", "death sound", "speed",
    "hsize", "height", "mass", "missile damage",
    "act sound", "bits"
};

char *ammo1[] = {
    "pistol", "shotgun", "launcher", "plasma"
};

char *ammo2[] = {
    "punch", "pistol", "shotgun", "chaingun", "launcher",
    "plasma", "bfg", "chainsaw"
};

char *ammoattr[] = {
    "ammo type", "bob frame 1", "bob frame 2", "bob frame 3",
    "shoot frame", "firing frame"
};

char *fattr[] = {
    "sprite no", "sprite subno", "duration", "code ptr",
    "next frame", "?2", "?3"
};

char *tnames[103] = {
    "Player",
    "Imp",
    "Trooper",
    "Sargeant",
    "Demon",
    "Spector",
    "Cacodemon",
    "Lost Soul",
    "Baron",
    "Spider Boss",
    "Cyberdemon",
    "Barrel",
    "Imp Fireball",
    "Caco Fireball",
    "Baron Fireball",
    "Rocket",
    "Plasma Bullet",
    "BFG Shot",
    "Bullet Puffs",
    "Blood Splats",
    "Teleport Flash",
    "Teleport Exit",
    "BFG Hit",
    "Green Armor",
    "Blue Armor",
    "Health Potion",
    "Armor Helmet",
    "Blue Keycard",
    "Red Keycard",
    "Yellow Keycard",
    "Yellow Skull Key",
    "Red Skull Key",
    "Blue Skull Key",
    "Stim Pack",
    "Medical Kit",
    "Soul Sphere",
    "Invulnerability",
    "Berserk Sphere",
    "Blur Sphere",
    "Radiation Suit",
    "Computer Map",
    "Lite Amp. Goggles",
    "Ammo Clip",
    "Box of Ammo",
    "Rocket",
    "Box of Rockets",
    "Energy Cell",
    "Energy Pack",
    "Shells",
    "Box of Shells",
    "Backpack",
    "BFG9000",
    "Chaingun",
    "Chainsaw",
    "Rocket Launcher",
    "Plasma Gun",
    "Shotgun",
    "Lamp",
    "Tall Green Pillar",
    "Short Green Pillar",
    "Tall Red Pillar",
    "Short Red Pillar",
    "Red Pillar w/Skull",
    "Pillar w/Heart",
    "Eye in Symbol",
    "Flaming Skulls",
    "Grey Tree",
    "Tall Blue Torch",
    "Tall Green Torch",
    "Tall Red Torch",
    "Short Blue Torch",
    "Short Green Torch",
    "Short Red Torch",
    "Brown Stub",
    "Technical Column",
    "Candle",
    "Candelabra",
    "Swaying Body",
    "Hanging Arms Out",
    "One-legged Body",
    "Hanging Torso",
    "Hanging Leg",
    "Hanging Arms Out 2",
    "Hanging Torso 2",
    "One-legged Body 2",
    "Hanging Leg 2",
    "Swaying Body 2",
    "Dead Cacodemon",
    "Dead Marine",
    "Dead Trooper",
    "Dead Demon",
    "Dead Lost Soul",
    "Dead Imp",
    "Dead Sargeant",
    "Guts and Bones",
    "Guts and Bones 2",
    "Skewered Heads",
    "Pool of Blood",
    "Pole with Skull",
    "Pile of Skulls",
    "Impaled Body",
    "Twitching Body",
    "Large Tree",
};

char *bitattr[] = {
    "Gettable Thing",
    "Obstacle",
    "Can be hurt",
    "Total Invis.",
    "Automatics",
    "Unknown",
    "Unknown",
    "Unknown",
    "Hangs from ceil",
    "Not-on-ground",
    "Proj/players",
    "Can get stuff",
    "No Clipping",
    "Unknown",
    "Float Monsters",
    "Semi-No Clip.",
    "Projectiles",
    "Unknown",
    "Partial Invis.",
    "Blood/puffs",
    "Unknown",
    "Unknown",
    "Counts for Kill%",
    "Counts for Item%",
    "Unknown",
    "Not in DMatch",
    "Color1",
    "Color2",
    "Unknown",
    "Unknown",
    "Unknown",
    "Unknown",
};

char *sprs[] = {
	"TROO", "SHTG", "PUNG", "PISG", "PISF", "SHTF", "CHGG", "CHGF",
	"MISG", "MISF", "SAWG", "PLSG", "PLSF", "BFGG", "BFGF", "BLUD",
	"PUFF", "BAL1", "BAL2", "BAL7", "PLSS", "PLSE", "MISL", "BFS1",
	"BFE1", "BFE2", "PLAY", "POSS", "SPOS", "SARG", "HEAD", "BOSS",
	"SKUL", "SPID", "CYBR", "TFOG", "ARM1", "ARM2", "BAR1", "BEXP",
	"BON1", "BON2", "BKEY", "RKEY", "YKEY", "BSKU", "RSKU", "YSKU",
	"STIM", "MEDI", "SOUL", "PINV", "PSTR", "PINS", "SUIT", "PMAP",
	"PVIS", "CLIP", "AMMO", "ROCK", "BROK", "CELL", "CELP", "SHEL",
	"SBOX", "BPAK", "BFUG", "MGUN", "CSAW", "LAUN", "PLAS", "SHOT",
	"COLU", "SMT2", "GOR1", "POL2", "POL5", "POL4", "POL3", "POL1",
	"POL6", "GOR2", "GOR3", "GOR4", "GOR5", "SMIT", "COL1", "COL2",
	"COL3", "COL4", "CAND", "CBRA", "COL6", "TRE1", "TRE2", "ELEC",
	"CEYE", "FSKU", "COL5", "TBLU", "TGRN", "TRED", "SMBT", "SMGT",
	"SMRT"
};

main(ac, av)
int ac;
char **av;
{
    FILE *in1, *in2;
    short x;
    long tbuf1[22], tbuf2[22];
    long fbuf1[7], fbuf2[7];
    int i, j;

    if (ac < 3) {
	fprintf(stderr, "dhdiff v1.0\nusage: dhdiff file1 file2\n");
	exit(1);
    }
    in1 = fopen(av[1], "rb");
    if (!in1) {
	fprintf(stderr, "can't open %s\n", av[1]);
	exit(1);
    }
    in2 = fopen(av[2], "rb");
    if (!in2) {
	fprintf(stderr, "can't open %s\n", av[2]);
	exit(1);
    }
    fread(&x, 1, sizeof x, in1);
    fread(&x, 1, sizeof x, in2);
    for (i = 0; i != 103; i++) {
	fread(tbuf1, 1, sizeof tbuf1, in1);
	fread(tbuf2, 1, sizeof tbuf2, in2);
	if (memcmp(tbuf1, tbuf2, sizeof tbuf1)) {
	    printf("%s (thing %d) differences:\n", tnames[i], i+1);
	    for (j = 0; j != 22; j++) {
		if (j == 21) {
		    int k, o1, o2;
		    long b1 = tbuf1[21];
		    long b2 = tbuf2[21];
		    unsigned long b = 1;
		    for (k = 0; k != 32; k++, b<<=1) {
			if ((o1 = (b1 & b)) != (o2 = (b2 & b)))
			    printf("  %s (bit %d) (%d -> %d)\n",
				bitattr[k], k, !!o1, !!o2);
		    }
		} else if (tbuf1[j] != tbuf2[j])
		    printf("  %s (%ld -> %ld)\n", tattr[j],
			tbuf1[j], tbuf2[j]);
	    }
	}
    }
    for (i = 0; i != 8+48; i++) {
	long x1, x2;
	fread(&x1, 4, 1, in1);
	fread(&x2, 4, 1, in2);
	if (x1 != x2) {
	    if (i < 4)
		printf("%s ammo capacity differs: (%ld -> %ld)\n", ammo1[i&3],
		    x1, x2);
	    else if (i < 8)
		printf("%s ammo item size differs: (%ld -> %ld)\n", ammo1[i&3],
		    x1, x2);
	    else
		printf("%s %s differs: (%ld -> %ld)\n",
		    ammo2[(i-8)/6], ammoattr[(i-8)%6],
		    x1, x2);
	}
    }
    for (i = 0; i != 512; i++) {
	fread(fbuf1, 1, sizeof fbuf1, in1);
	fread(fbuf2, 1, sizeof fbuf2, in2);
	if (feof(in1) || feof(in2))
	    break;
	if (memcmp(fbuf1, fbuf2, sizeof fbuf1)) {
	    printf("frame %d differences:\n", i);
	    for (j = 0; j != 7; j++) {
		if (fbuf1[j] != fbuf2[j]) {
		    if (!j)
			printf("  %s (%s -> %s)\n",
			    fattr[j], sprs[fbuf1[j]],
			    sprs[fbuf2[j]]);
		    else
			printf("  %s (%ld -> %ld)\n", fattr[j],
			    fbuf1[j], fbuf2[j]);
		}
	    }
	}
    }
}
